
/* Auther: Hilda Chang He 
** Date: 2016 Winter
**
**
** This is a data visualization project. 
** The data is from Seattle Public Library. Thanks for the supply from George.
** The project idea is to see how new books perform during time passed.
** The visualization design is inspired by Karl and the OLAP Cube concept.
** This project visualize every checkout records in SPL based on its checkOut time, checkOut order and loan duration. 
** And data are catagorized as fiction and non-fictions.
**
**/


import controlP5.*;
import peasy.*;
import java.awt.*;
PeasyCam cam;
ControlP5 cp5;

//for testing now, use 2015 --> keep it, dono why but keep it plz
int startYear = 2015;

//parameters
int xrange = 800;
int yrange = 500; // 200 + 100 + 200
int zrange = 800;
int camDepth = 600;
int xMargin = 100;

int numOfSet = 1;

//Load tables: fiction2015, nonfic2015
DataTable fiction2015;
DataTable nonfic2015;
DataTable fiction2014;
DataTable nonfic2014;
DataTable fiction2013;
DataTable nonfic2013;

//view mode
int viewAngle = 0;
boolean switch2013 = false;
boolean switch2014 = false;
boolean switch2015 = true;
boolean title = true;

//interactive functions
int[][] points;
String name;
int copies;
int checkOutTimes;
String bookDescription;

//color container
int yearIndicator;

CheckBox yearCheckbox;

PFont font;

void setup(){
  //set screen size
  //size(1200, 700, P3D);
  size(900, 600, P3D);
  smooth();
  //get peasy cam ready
  cam = new PeasyCam(this, (xrange - (numOfSet -1) * xrange)/2, (yrange-100)/2, -zrange/2, zrange/1.5 + camDepth * numOfSet * 0.6);
  
  //load data
  fiction2015 = new DataTable("fiction2015.csv", 2015, true);
  println();
  nonfic2015 = new DataTable("nonfiction2015.csv", 2015, false);
  println();
  fiction2014 = new DataTable("fiction2014.csv", 2014, true);
  println();
  nonfic2014 = new DataTable("nonfiction2014.csv", 2014, false);
  println();
  fiction2013 = new DataTable("fiction2013.csv", 2013, true);
  println();
  nonfic2013 = new DataTable("nonfiction2013.csv", 2013, false);
  
  fiction2013.createMeshes();
  nonfic2013.createMeshes();
  fiction2014.createMeshes();
  nonfic2014.createMeshes();
  fiction2015.createMeshes();
  nonfic2015.createMeshes();
  
  int n2013 = fiction2013.lines.getVertexCount() + fiction2013.points.getVertexCount() + nonfic2013.lines.getVertexCount() + nonfic2013.points.getVertexCount();
  int n2014 = fiction2014.lines.getVertexCount() + fiction2014.points.getVertexCount() + nonfic2014.lines.getVertexCount() + nonfic2014.points.getVertexCount();
  int n2015 = fiction2015.lines.getVertexCount() + fiction2015.points.getVertexCount() + nonfic2015.lines.getVertexCount() + nonfic2015.points.getVertexCount();
  
  println("Num verts:");
  println("  2013: " + n2013);
  println("  2014: " + n2014);
  println("  2015: " + n2015);
  println("  Total: " + (n2013+n2014+n2015));
  println("<<<<<<<<<<<<<<<<<<<<<<finish initialization!!!!!!<<<<<<<<<<<<<<<<<<<<<<<<");

  //color initiation
  
  //get control panel ready
  cp5 = new ControlP5(this);
  
  controlPanel();
  
  //test findBooksByName()     ;)
  //name = "Her a novel";
  //points = fiction2015.findBooksByName(name);
  //if(points == null){
  //  println("nothing found");
  //}else{
  //  for(int i = 0; i< points.length; i++ ){
  //    println(points[i][0] + "  " + points[i][1] + "  " + points[i][2]);
  //  }
  //}
  
  
  
}

void draw(){
  background(150);
  
  //draw pins of fiction2015
  if(viewAngle == 0){
     if(switch2015){
       shape(fiction2015.lines); shape(fiction2015.points);
       shape(nonfic2015.lines); shape(nonfic2015.points);
     }
     if(switch2014){
      shape(fiction2014.lines); shape(fiction2014.points);
      shape(nonfic2014.lines); shape(nonfic2014.points);
  
     }
     if(switch2013){
      shape(fiction2013.lines); shape(fiction2013.points);
      shape(nonfic2013.lines); shape(nonfic2013.points);
     }
     drawlablesF();
  }
 if(viewAngle == 1 || viewAngle == 2){
     if(switch2015){
      shape(fiction2015.lines); shape(fiction2015.points);
     }
     if(switch2014){
      shape(fiction2014.lines); shape(fiction2014.points);
     }
     if(switch2013){
      shape(fiction2013.lines); shape(fiction2013.points);
     }
     drawlablesF();
     pushMatrix();
     translate(2 * xrange + 100, yrange, 0);
     rotate(PI);
     if(switch2015){
      shape(nonfic2015.lines); shape(nonfic2015.points);
     }
     if(switch2014){
      shape(nonfic2014.lines); shape(nonfic2014.points);
     }
     if(switch2013){
      shape(nonfic2013.lines); shape(nonfic2013.points);
     }
     popMatrix();
  }

  gui();
  
  
  //test drawCurve
  drawCurve(points);
  //if (frameCount % 50 == 0) frame.setTitle("Books! fps: " + str(frameRate));

  //for test
  //fill(0, 20); 
  //box(200);
  
  //strokeWeight(5);
  //stroke(0);
  //drawPin(new PVector(0,100,0));
  
}