SELECT 
	spl.transactions.bibNumber,
	spl.transactions.itemNumber,
	spl.title.title,
	spl.transactions.checkOut,
    TIMESTAMPDIFF(DAY, checkOut, checkInFirst)  AS 'check Out Days'
    
FROM
    spl.transactions, spl.callNumber, spl.deweyClass, spl.collectionCode, spl.itemType, spl.title

WHERE
	spl.callNumber.itemNumber = spl.transactions.itemNumber
	AND	spl.deweyClass.bibNumber = spl.transactions.bibNumber
	AND spl.collectionCode.itemNumber = spl.transactions.itemNumber
	AND spl.itemType.itemNumber = spl.transactions.itemNumber
	And spl.title.bibNumber = spl.transactions.bibNumber
    AND substring(collectionCode from 3 for 3) = 'new'
	AND right(callNumber, 4) = 2015
	AND length(deweyClass) = 0  
	AND itemType = 'acbk'
	AND checkOut != "1970-01-01 00:00:00"
	AND TIMESTAMPDIFF(DAY, checkOut, checkInFirst) >= 0
ORDER BY checkOut,  bibNumber, itemNumber 